VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4800
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4800
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtInfo 
      BackColor       =   &H00C0C0C0&
      Height          =   2535
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   480
      Width           =   4575
   End
   Begin VB.CommandButton cmdGetInfo 
      Caption         =   "Get Info"
      Default         =   -1  'True
      Height          =   375
      Left            =   3720
      TabIndex        =   1
      Top             =   0
      Width           =   855
   End
   Begin VB.DriveListBox drvInfo 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Const DRIVE_UNKNOWN = 0
Private Const DRIVE_NO_ROOT_DIR = 1
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6

Private Const FILE_CASE_PRESERVED_NAMES = &H2
Private Const FILE_CASE_SENSITIVE_SEARCH = &H1
Private Const FILE_UNICODE_ON_DISK = &H4
Private Const FILE_PERSISTENT_ACLS = &H8
Private Const FILE_FILE_COMPRESSION = &H10
Private Const FILE_VOLUME_IS_COMPRESSED = &H8000
Private Const FILE_SUPPORTS_ENCRYPTION = &H20000
Private Const FILE_SUPPORTS_OBJECT_IDS = &H10000
Private Const FILE_SUPPORTS_REPARSE_POINTS = &H80
Private Const FILE_SUPPORTS_SPARSE_FILES = &H40
Private Const FILE_VOLUME_QUOTAS = &H20

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const EM_SETTABSTOPS = &HCB
Private Sub cmdGetInfo_Click()
Dim volume_name As String
Dim file_system_name As String
Dim info_status As Long
Dim serial_number As Long
Dim max_component_length As Long
Dim file_system_flags As Long
Dim drive_name As String
Dim drive_type As Long
Dim txt As String
Dim pos As Integer

    txtInfo.Text = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    volume_name = Space(256)
    file_system_name = Space(256)

    drive_name = drvInfo.Drive
    pos = InStr(drive_name, ":")
    If pos > 0 Then drive_name = Left$(drive_name, pos)
    If Right$(drive_name, 1) <> "\" Then drive_name = drive_name & "\"
    drive_type = GetDriveType(drive_name)

    info_status = GetVolumeInformation(drive_name, _
        volume_name, Len(volume_name), serial_number, _
        max_component_length, file_system_flags, _
        file_system_name, Len(file_system_name))

     volume_name = CleanString(volume_name)
     file_system_name = CleanString(file_system_name)
 
    txt = _
        "Drive Name:" & vbTab & drive_name & vbCrLf & _
        "Volume Name:" & vbTab & "'" & volume_name & "'" & vbCrLf & _
        "Serial Number:" & vbTab & serial_number & vbCrLf & _
        "Max Component Length:" & vbTab & max_component_length
    If max_component_length = 255 Then
        txt = txt & " (supports long file names)"
    End If
    txt = txt & vbCrLf & _
        "File System Flags:" & vbTab & file_system_flags & vbCrLf

    If file_system_flags And FILE_CASE_PRESERVED_NAMES Then
        txt = txt & vbTab & "Preserves Names" & vbCrLf
    End If
    If file_system_flags And FILE_CASE_SENSITIVE_SEARCH Then
        txt = txt & vbTab & "Case Sensitive Search" & vbCrLf
    End If
    If file_system_flags And FILE_UNICODE_ON_DISK Then
        txt = txt & vbTab & "Unicode On Disk" & vbCrLf
    End If
    If file_system_flags And FILE_PERSISTENT_ACLS Then
        txt = txt & vbTab & "Persistent ACLS" & vbCrLf
    End If
    If file_system_flags And FILE_FILE_COMPRESSION Then
        txt = txt & vbTab & "File Compression" & vbCrLf
    End If
    If file_system_flags And FILE_VOLUME_IS_COMPRESSED Then
        txt = txt & vbTab & "Volume Is Compressed" & vbCrLf
    End If
    If file_system_flags And FILE_SUPPORTS_ENCRYPTION Then
        txt = txt & vbTab & "Supports Encryption" & vbCrLf
    End If
    If file_system_flags And FILE_SUPPORTS_OBJECT_IDS Then
        txt = txt & vbTab & "Supports Object IDs" & vbCrLf
    End If
    If file_system_flags And FILE_SUPPORTS_REPARSE_POINTS Then
        txt = txt & vbTab & "Supports Reparse Points" & vbCrLf
    End If
    If file_system_flags And FILE_SUPPORTS_SPARSE_FILES Then
        txt = txt & vbTab & "Supports Sparse Files" & vbCrLf
    End If
    If file_system_flags And FILE_VOLUME_QUOTAS Then
        txt = txt & vbTab & "Volume Quotas" & vbCrLf
    End If

    txt = txt & _
        "File System Name:" & vbTab & "'" & file_system_name & "'" & vbCrLf & _
        "Drive Type" & vbTab

    Select Case drive_type
        Case DRIVE_UNKNOWN
            txt = txt & "Unknown"
        Case DRIVE_NO_ROOT_DIR
            txt = txt & "No Root Dir"
        Case DRIVE_REMOVABLE
            txt = txt & "Removable"
            If info_status = 0 Then
                txt = txt & " (empty)"
            Else
                txt = txt & " (loaded)"
            End If
        Case DRIVE_FIXED
            txt = txt & "Fixed"
        Case DRIVE_REMOTE
            txt = txt & "Remote"
        Case DRIVE_CDROM
            txt = txt & "CD ROM"
            If info_status = 0 Then
                txt = txt & " (empty)"
            Else
                txt = txt & " (loaded)"
            End If
        Case DRIVE_RAMDISK
            txt = txt & "Ram Disk"
        Case Else
            txt = txt & "Error (" & Format$(drive_type) & ")"
    End Select
    txt = txt & vbCrLf

    txtInfo.Text = txt
    Screen.MousePointer = vbDefault
End Sub

' Truncate the string at a NULL character if it
' contains one and remove leading and trailing spaces.
Private Function CleanString(ByVal txt As String) As String
Dim pos As Integer

    pos = InStr(txt, vbNullChar)
    If pos > 0 Then txt = Left$(txt, pos - 1)
    CleanString = Trim$(txt)
End Function
' Set a tab in the result TextBox.
Private Sub Form_Load()
Dim tabs(2) As Long

    tabs(0) = 20
    tabs(1) = 90

    ' Set the tabs.
    SendMessage txtInfo.hwnd, EM_SETTABSTOPS, 2, tabs(0)
End Sub

Private Sub Form_Resize()
Dim hgt As Single
Dim wid As Single

    wid = ScaleWidth - cmdGetInfo.Width - 60
    If wid < 120 Then wid = 120
    drvInfo.Width = wid

    cmdGetInfo.Left = drvInfo.Width + 60

    hgt = ScaleHeight - txtInfo.Top
    If hgt < 120 Then hgt = 120
    txtInfo.Move 0, txtInfo.Top, ScaleWidth, hgt
End Sub


